; See convert-perm-to-how-many-annotated.lisp for a detailed discussion of
; how the proof of the final defthm was found.

(in-package "ACL2")

(include-book "sorting/perm" :dir :system)

(defun how-many (e x)
  (cond
   ((endp x) ; or, (atom x)
    0)
   ((equal e (car x))
    (1+ (how-many e (cdr x))))
   (t
    (how-many e (cdr x)))))

(defun perm-counter-example (x y)
  (cond ((atom x)
         (car y))
        ((not (memb (car x) y))
         (car x))
        (t (perm-counter-example (cdr x) (rm (car x) y)))))

(defthm not-memb-implies-how-many-is-0
  (implies (not (memb a x))
           (equal (how-many a x) 0)))

(defthm how-many-rm
  (equal (how-many a (rm b x))
         (if (and (equal a b)
                  (memb a x))
             (1- (how-many a x))
           (how-many a x))))

(defthm convert-perm-to-how-many
  (equal (perm x y)
         (equal (how-many (perm-counter-example x y) x)
                (how-many (perm-counter-example x y) y))))
